/*
 * distrib.h
 *
 * Definitions for functions manipulating distributions
 *
 */

/*
 *    Copyright (c) 2001 Compaq Computer Corporation
 *
 *    SOFTWARE RELEASE
 *    
 *    Permission is hereby granted, free of charge, to any person obtaining a
 *    copy of this software and associated documentation files (the
 *    "Software"), to deal in the Software without restriction, including
 *    without limitation the rights to use, copy, modify, merge, publish,
 *    distribute, sublicense, and/or sell copies of the Software, and to
 *    permit persons to whom the Software is furnished to do so, subject to
 *    the following conditions:
 *
 *	Redistributions of source code must retain the above copyright
 *	notice, this list of conditions and the following disclaimer.
 *
 *	Redistributions in binary form must reproduce the above
 *	copyright notice, this list of conditions and the following
 *	disclaimer in the documentation and/or other materials provided
 *	with the distribution.
 *
 *	Except as contained in this notice, the name of COMPAQ Computer
 *	Corporation shall not be used in advertising or otherwise to
 *	promote the sale, use or other dealings in this Software
 *	without prior written authorization from COMPAQ Computer
 *	Corporation.
 *    
 *    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 *    OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 *    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 *    IN NO EVENT SHALL COMPAQ COMPUTER CORPORATION BE LIABLE FOR ANY CLAIM,
 *    DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
 *    OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR
 *    THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

/*
 * History:
 * $Log: distrib.h,v $
 * Revision 1.7  2002/01/16  01:04:07  mogul
 * Added UpdateLinDistribTruncBW()
 *
 * Revision 1.6  2001/12/28  22:59:37  mogul
 * Support for PctCumDistrib printing.
 *
 * Revision 1.5  2001/12/12  00:56:44  mogul
 * Added computation of medians
 *
 * Revision 1.4  2001/12/11  01:57:40  mogul
 * Added copyright notice
 *
 * Revision 1.3  2001/12/01  01:51:29  mogul
 * Added ConfigureLinDistrib, UpdateLinDistribTrunc
 *
 * Revision 1.2  2001/11/20  22:46:52  mogul
 * *** empty log message ***
 *
 * Revision 1.1  2001/08/22  19:45:45  mogul
 * Initial revision
 *
 */

long *InitLogDistrib();
void UpdateLogDistrib(long *distrib, int xval);
void UpdateLogDistribBW(long *distrib, int xval, int len);
void PrintLogDistrib(FILE *outf, long *distrib);
void PrintLogCumDistrib(FILE *outf, long *distrib);
void PrintLogPctCumDistrib(FILE *outf, long *distrib);
void BBoxLogDistrib(long *distrib,
			long *xminp, long *xmaxp, long *yminp, long *ymaxp,
			long *firstp, long *totp);
float LogDistribMedian(long *distrib);

void ConfigureLinDistrib(int maxindex);
long *InitLinDistrib();
void UpdateLinDistrib(long *distrib, int xval);
void UpdateLinDistribTrunc(long *distrib, int xval, int truncval);
void UpdateLinDistribBW(long *distrib, int xval, int len);
void UpdateLinDistribTruncBW(long *distrib, int xval, int truncval, int len);
void PrintLinDistrib(FILE *outf, long *distrib);
void PrintLinCumDistrib(FILE *outf, long *distrib);
void PrintLinPctCumDistrib(FILE *outf, long *distrib);
void BBoxLinDistrib(long *distrib,
			long *xminp, long *xmaxp, long *yminp, long *ymaxp,
			long *firstp, long *totp);
long LinDistribMedian(long *distrib);

